# MEtaPhos | iGEM Aachen 2022 

Built using [the iGEM Wiki Starter Pack](https://igem-wiki-starter.readthedocs.io) v0.1.2 by iGEM BITS Goa and ideas from iGEM Aachen 2021. *Special thanks to Frithjof, Malte and Clemens!*

## How to work with GitLab and all this stuff

### Folder structure

#### Where can I find the actual text files?

All text files that should be manually edited are located under `src/pages`.
There you will find `.pug`-files for all pages in the wiki.
Most of these contain a block of text written in Markdown.
Others, like `Members.pug`, look rather cryptic.
The corresponding pages are generated in such a way that layout and content are separated much better.

You do not need to work with any files in the folders `igem` or `dist`.
These are generated automatically from our `.pug`-files.

#### Where should I put images?

Images belong in the folder `src/assets/img`.
Right now, there are almost no subfolders in there, but feel free to create one for better clarity.

#### How should I link images in texts?

Images can be linked in texts with these two lines:

```
- var imgpath = "https://uploads.igem.com/https://uploads.igem.org/teams/4138/wiki/img/team"
+image(1, imgpath, "Description of the image")
```

The first line descripes the path to the image. Just copy the fitting URL there.


In the second line, the `1` must be updated so that all images are numbered in order of appearance.
Change `Description of the image` to the description you want to be shown under your image.

##### Formatting of images

Note that these two lines should not be inserted *inside* of a markdown-block.
Instead, it should be inserted under a block, so on the same level of indentation.
If you want to write more text under the image, just create a new markdown-block.
This could look something like this:

```
block article
    :markdown-it(html)

        # First Markdown-Block with very interesting content.

        Add some text here.

    - var imgpath = "" + require("../assets/img/Description--josh-withers.jpg")["default"]
    +image(1, imgpath, "Picture by Josh Withers on Unsplash")

    :markdown-it
        # Second Markdown-Block with even more interesting content.
        
        More Text
```

In general, it is very important that you get the indentation right.
`:markdown-it(html)` should be indented four spaces (or one tab), while its content should be indented eight spaces.

## How to build this website
To build this website just install the dependencies with `npm install`, start a development server with `npm start` or build the website with `npm run build`.
