import pylab
from mpl_toolkits import mplot3d
import numpy as np
import matplotlib.pyplot as plt

def Plot_ODE_All(y,t):
    pylab.plot(t,y[0],'r', label='Phosphate-Wastewater')
    pylab.plot(t,y[1],'r--', label='Phosphate')
    pylab.plot(t,y[2],'b', label='PBP Active')
    pylab.plot(t,y[3],'c', label='PBP Inactive')
    pylab.plot(t,y[4],'g', label='PBP Active Bound')
    pylab.plot(t,y[5],'y', label='PBP Inactive Bound')
    pylab.xlabel('time(min)')
    pylab.ylabel('concentration(g/l)')
    pylab.legend()
    pylab.show()


def Plot_ODE_Light_On(y,t):
    pylab.plot(t,y[0],'r', label='Phosphate-Wastewater')
    pylab.plot(t,y[2],'b', label='PBP Active')
    pylab.plot(t,y[4],'g', label='PBP Active Bound')
    pylab.xlabel('time(min)')
    pylab.ylabel('concentration(g/l)')
    pylab.legend()
    pylab.show()

def Plot_ODE_Light_Off(y,t):
    pylab.plot(t,y[1],'r', label='Phosphate')
    pylab.plot(t,y[2],'b', label='PBP Active')
    pylab.plot(t,y[3],'c', label='PBP Inactive')
    pylab.plot(t,y[4],'g', label='PBP Active Bound')
    pylab.plot(t,y[5],'y', label='PBP Inactive Bound')
    pylab.xlabel('time(min)')
    pylab.ylabel('concentration(g/l)')
    pylab.legend()
    pylab.show()


def Subplot_4(y1,y2,y3,y4,t1,t2,t3,t4):
    fig, axs = plt.subplots(2, 2)
    axs[0, 0].plot(t1,y1[0],'r', label='Phosphate-Wastewater')
    axs[0, 0].plot(t1,y1[1],'r--', label='Phosphate')
    axs[0, 0].plot(t1,y1[2],'b', label='PBP Active')
    axs[0, 0].plot(t1,y1[3],'c', label='PBP Inactive')
    axs[0, 0].plot(t1,y1[4],'g', label='PBP Active Bound')
    axs[0, 0].plot(t1,y1[5],'y', label='PBP Inactive Bound')
    axs[0, 0].set_title('Large Flow')
    axs[0, 1].plot(t2,y2[0],'r', label='Phosphate-Wastewater')
    axs[0, 1].plot(t2,y2[1],'r--', label='Phosphate')
    axs[0, 1].plot(t2,y2[2],'b', label='PBP Active')
    axs[0, 1].plot(t2,y2[3],'c', label='PBP Inactive')
    axs[0, 1].plot(t2,y2[4],'g', label='PBP Active Bound')
    axs[0, 1].plot(t2,y2[5],'y', label='PBP Inactive Bound')
    axs[0, 1].set_title('Small Flow')
    axs[1, 0].plot(t3,y3[0],'r', label='Phosphate-Wastewater')
    axs[1, 0].plot(t3,y3[1],'r--', label='Phosphate')
    axs[1, 0].plot(t3,y3[2],'b', label='PBP Active')
    axs[1, 0].plot(t3,y3[3],'c', label='PBP Inactive')
    axs[1, 0].plot(t3,y3[4],'g', label='PBP Active Bound')
    axs[1, 0].plot(t3,y3[5],'y', label='PBP Inactive Bound')
    axs[1, 0].set_title('Short Time')
    axs[1,1].plot(t4,y4[0],'r', label='Phosphate-Wastewater')
    axs[1,1].plot(t4,y4[1],'r--', label='Phosphate')
    axs[1,1].plot(t4,y4[2],'b', label='PBP Active')
    axs[1,1].plot(t4,y4[3],'c', label='PBP Inactive')
    axs[1,1].plot(t4,y4[4],'g', label='PBP Active Bound')
    axs[1,1].plot(t4,y4[5],'y', label='PBP Inactive Bound')
    axs[1, 1].set_title('Long Time')

    for ax in axs.flat:
        ax.set(xlabel='time(min)', ylabel='concentration(g/l)')

    # Hide x labels and tick labels for top plots and y ticks for right plots.
    for ax in axs.flat:
        ax.label_outer()
    plt.show()
    

def array_vektor(list):
    a=[]
    new_list = []
    j=0
    while j < len(list[0]):
        for i in list:
            a.append(i[j])
        new_list.append(np.array(a))
        a=[]
        j +=1
    return new_list